"use strict";

exports.__esModule = true;
exports.shared = exports.PureComponent = exports.useImperativeHandle = exports.useReducer = exports.useMemo = exports.useCallback = exports.useRef = exports.useLayoutEffect = exports.useEffect = exports.useContext = exports.useState = void 0;

var _createElement2 = _interopRequireDefault(require("./createElement"));

exports.createElement = _createElement2.default;

var _createContext2 = _interopRequireDefault(require("./createContext"));

exports.createContext = _createContext2.default;

var _createRef2 = _interopRequireDefault(require("./createRef"));

exports.createRef = _createRef2.default;

var _forwardRef2 = _interopRequireDefault(require("./forwardRef"));

exports.forwardRef = _forwardRef2.default;

var _hooks = require("./hooks");

exports.useState = _hooks.useState;
exports.useContext = _hooks.useContext;
exports.useEffect = _hooks.useEffect;
exports.useLayoutEffect = _hooks.useLayoutEffect;
exports.useRef = _hooks.useRef;
exports.useCallback = _hooks.useCallback;
exports.useMemo = _hooks.useMemo;
exports.useReducer = _hooks.useReducer;
exports.useImperativeHandle = _hooks.useImperativeHandle;

var _memo2 = _interopRequireDefault(require("./memo"));

exports.memo = _memo2.default;

var _fragment = _interopRequireDefault(require("./fragment"));

exports.Fragment = _fragment.default;

var _render2 = _interopRequireDefault(require("./render"));

exports.render = _render2.default;

var _component = _interopRequireWildcard(require("./vdom/component"));

exports.Component = _component.default;
exports.PureComponent = _component.PureComponent;

var _version2 = _interopRequireDefault(require("./version"));

exports.version = _version2.default;

var _host = _interopRequireDefault(require("./vdom/host"));

var _instance = _interopRequireDefault(require("./vdom/instance"));

var _element = _interopRequireDefault(require("./vdom/element"));

var _flattenChildren = _interopRequireDefault(require("./vdom/flattenChildren"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var shared = {
  Host: _host.default,
  Instance: _instance.default,
  Element: _element.default,
  flattenChildren: _flattenChildren.default
};
exports.shared = shared;